> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save payments

> Save new (or update existing) payments



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/payments
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/payments:
    post:
      tags:
        - Payments
      summary: Save payments
      description: Save new (or update existing) payments
      operationId: postPayments
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamPaymentPostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponsePaymentGetDto'
        '207':
          description: Some payments failed to save. See response body for error details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponsePaymentGetDto'
        '400':
          description: All payments failed to save.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponsePaymentGetDto'
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - EmbedToken: []
components:
  schemas:
    MultiParamPaymentPostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/PaymentPostDto'
    ResponseListMultiResponsePaymentGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponsePaymentGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    PaymentPostDto:
      required:
        - amount
        - date
        - description
      type: object
      properties:
        id:
          type: string
          description: Id of the payment, required when updating an existing payment
          example: ptxn_158998869
        date:
          type: string
          description: Date of the payment
          format: date
          nullable: false
          example: '2025-06-26'
        amount:
          type: integer
          description: Total amount of the payment
          format: int32
          nullable: false
          example: 273479
        description:
          type: string
          description: Payment description
          nullable: false
        notes:
          type: string
          description: Notes for the payment
          nullable: true
          example: June Payroll
        status:
          type: string
          description: Status of the payment
          nullable: false
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        reviewStatus:
          type: string
          description: Review status of the payment
          nullable: false
          enum:
            - RECONCILIATION_DISCREPANCY
            - USER_REVIEW_REQUIRED
            - ACCOUNTANT_REVIEW_REQUIRED
            - PARTNER_REVIEW_REQUIRED
            - AWAITING_MATCH
            - STAGED
            - RECONCILED
        apiSourceId:
          type: string
          description: Id of the payment on associated API
          nullable: true
        bankAccountId:
          type: string
          description: Id of the bank account associated with this payment
          nullable: true
          example: bka_7542850
        dimensionValueIds:
          type: array
          nullable: true
          items:
            type: string
        customerId:
          type: string
          description: Id of the customer assigned to this payment
          nullable: true
          example: cus_4852707
        vendorId:
          type: string
          description: Id of the vendor associated with this payment
          nullable: true
          example: vnd_28868401
        categoryId:
          type: string
          description: Id of the category associated with this payment
          nullable: true
          example: ctg_58932890
        glAccountId:
          type: string
          description: GL account id, referencing an account in the chart of accounts
          nullable: false
          example: gla_38560327
        children:
          type: array
          nullable: true
          items:
            required:
              - amount
              - glAccountId
            type: object
            properties:
              id:
                type: string
                description: >-
                  Id of the child payment, required when updating an existing
                  child payment
                example: tli_349412
              amount:
                type: integer
                description: Total amount of the child payment (in cents)
                format: int32
                nullable: false
                example: 134051
              apiItemId:
                type: string
                description: Id of the child payment item on associated API
                nullable: true
              dimensionValueIds:
                type: array
                nullable: true
                items:
                  type: string
              customerId:
                type: string
                description: Id of the customer assigned to this child payment
                nullable: true
              vendorId:
                type: string
                description: Id of the vendor associated with this child payment
                nullable: true
              categoryId:
                type: string
                description: Id of the category associated with this child payment
                nullable: true
              glAccountId:
                type: string
                description: GL account id, referencing an account in the chart of accounts
                nullable: false
              invoiceId:
                type: string
                description: Id of the invoice that this payment paid for
                nullable: true
              billId:
                type: string
                description: Id of the bill that this payment paid for
                nullable: true
        customData:
          $ref: '#/components/schemas/JsonNode'
    MultiResponsePaymentGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/PaymentGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    JsonNode:
      type: object
      properties:
        empty:
          type: boolean
        array:
          type: boolean
        'null':
          type: boolean
        object:
          type: boolean
        float:
          type: boolean
        string:
          type: boolean
        number:
          type: boolean
        missingNode:
          type: boolean
        valueNode:
          type: boolean
        nodeType:
          type: string
          enum:
            - ARRAY
            - BINARY
            - BOOLEAN
            - MISSING
            - 'NULL'
            - NUMBER
            - OBJECT
            - POJO
            - STRING
        pojo:
          type: boolean
        integralNumber:
          type: boolean
        floatingPointNumber:
          type: boolean
        short:
          type: boolean
        int:
          type: boolean
        long:
          type: boolean
        double:
          type: boolean
        bigDecimal:
          type: boolean
        bigInteger:
          type: boolean
        textual:
          type: boolean
          deprecated: true
        boolean:
          type: boolean
        binary:
          type: boolean
        container:
          type: boolean
        embeddedValue:
          type: boolean
      description: >-
        Custom JSON in which you can store any data with max length of 2000
        characters
      nullable: true
      example:
        internal_key: some_internal_key
        some_other_field: 23434
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    PaymentGetDto:
      required:
        - amount
        - apiName
        - apiSourceId
        - bankAccount
        - bankTransaction
        - category
        - children
        - customer
        - date
        - description
        - dimensionValues
        - displayName
        - glAccount
        - id
        - notes
        - reviewStatus
        - status
        - type
        - vendor
      type: object
      properties:
        id:
          type: string
          description: Id of the payment
          example: ptxn_158998869
        type:
          type: string
          description: Type of the payment
          enum:
            - EXPENSE
            - REVENUE
            - TRANSFER_IN
            - TRANSFER_OUT
            - TAX_EXPENSE
            - INVOICE_REVENUE
            - PAYMENT_IN
            - PAYMENT_OUT
            - PAYROLL_EXPENSE
            - BILL_EXPENSE
            - LOAN_EXPENSE
        date:
          type: string
          description: Date of the payment
          format: date
          example: '2025-06-26'
        amount:
          type: integer
          description: Total amount of the payment
          format: int32
          example: 273479
        displayName:
          type: string
          description: Payment display name, useful for displaying this payment to a user
          example: Gusto
        description:
          type: string
          description: Payment description
          example: 'WITHDRAWAL ACH GUSTO TAXID: 4001'
        notes:
          type: string
          description: Notes for the payment
          nullable: true
          example: June Payroll
        status:
          type: string
          description: Status of the payment
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        reviewStatus:
          type: string
          description: Review status of the payment
          example: RECONCILED
          enum:
            - RECONCILIATION_DISCREPANCY
            - USER_REVIEW_REQUIRED
            - ACCOUNTANT_REVIEW_REQUIRED
            - PARTNER_REVIEW_REQUIRED
            - AWAITING_MATCH
            - STAGED
            - RECONCILED
        apiName:
          type: string
          description: Name of the API from which this payment originated
          example: PLAID
          enum:
            - BOX
            - CLOVER
            - STRIPE
            - PLAID
            - KNOX
            - UBER
            - FRESHBOOKS
            - HARVEST
            - KW
            - FRESHBOOKS2
            - CAPITAL_ONE
            - SQUARE
            - DOTLOOP
            - REALOGY
            - UPWORK
            - SHOPIFY
            - DEDUCTR
            - ENTERPRISE
            - MOXIWORKS
            - APPDIRECT
            - LONEWOLF
            - LONEWOLF_TRANSACTIONDESK
            - SAMPLE_BANK
            - TAXBOT
            - GUSTO
            - XERO
            - UNIT
            - MOOV
            - QBO
            - QUALPAY
            - BENCH
            - PARTNER_IMPLEMENTATION
            - CHECK
            - RUTTER
            - WAVE
            - MANUAL_ENTRY
            - CSV_IMPORT
            - ADYEN
            - PAYABLI
        apiSourceId:
          type: string
          description: Id of the payment on associated API
          nullable: true
          example: QeXqN7XJT50dwE4S19ZgVv4nnhLvjX7
        bankAccount:
          $ref: '#/components/schemas/BankAccountExpanded'
        dimensionValues:
          maxItems: 4
          type: array
          items:
            $ref: '#/components/schemas/DimensionValueExpanded'
        customer:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/CustomerExpanded'
        vendor:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/VendorExpanded'
        category:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/CategoryExpanded'
        glAccount:
          $ref: '#/components/schemas/GlAccountExpanded'
        bankTransaction:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/MatchingBankTransactionExpanded'
        children:
          type: array
          items:
            $ref: '#/components/schemas/PaymentChildGetDto'
        customData:
          $ref: '#/components/schemas/JsonNode'
      description: The data generated by the action performed.
    BankAccountExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the bank account
          example: bka_7542850
        name:
          type: string
          description: Name of the bank account
          example: Business Checking
        displayName:
          type: string
          description: Display Name of the bank account
          example: Business Checking *1687
      description: Bank account of the matching bank transaction
    DimensionValueExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension value
          example: dv_593051
        dimension:
          $ref: '#/components/schemas/DimensionExpanded'
        name:
          type: string
          description: Name of the dimension value
          example: Mid-Atlantic
        child:
          $ref: '#/components/schemas/ChildDimensionValue'
      description: List of dimension values associated with this time entry
    CustomerExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the customer
          example: cus_4852707
        name:
          type: string
          description: Name of the customer
          example: Abigail Adams
        email:
          type: string
          description: Email of the customer
          example: abigail@tight.com
      description: Customer associated with this time entry
      nullable: true
    VendorExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the vendor
          example: vnd_28868401
        name:
          type: string
          description: Name of the vendor
          example: Gusto
      description: Vendor associated with this child payment
      nullable: true
    CategoryExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the category
          example: ctg_58932890
        name:
          type: string
          description: Name of the category
          example: Wages
        iconUrl:
          type: string
          description: Icon URL of the category
          example: https://cdn.sandbox.tight.com/icons/expenseCategories/payroll.svg
      description: Category associated with this child payment
      nullable: true
    GlAccountExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the GL account
          example: gla_38560327
        name:
          type: string
          description: Name of the GL account
          example: Officer(s) Salaries and Wages
        accountNo:
          type: string
          description: Number of the GL account
          example: '60210'
        type:
          type: string
          description: Type the GL account
          example: EXPENSE
          enum:
            - ASSET
            - LIABILITY
            - EQUITY
            - INCOME
            - COGS
            - EXPENSE
            - OTHER_INCOME
            - OTHER_EXPENSE
            - SUSPENSE
        iconUrl:
          type: string
          description: Icon URL of the GL account
          example: https://cdn.sandbox.tight.com/icons/glAccountTypes/expense.png
        displayName:
          type: string
          description: Display name of the GL account
          example: '#60210 Officer(s) Salaries and Wages'
      description: GL account details
    MatchingBankTransactionExpanded:
      type: object
      properties:
        id:
          type: string
          description: Id of the matching bank transaction
        apiSourceId:
          type: string
          description: Id from the source of matching bank transaction
          nullable: true
        amount:
          type: integer
          description: Amount of the matching bank transaction (in cents)
          format: int32
        date:
          type: string
          description: Date of the matching bank transaction
          format: date
        description:
          type: string
          description: Description of the matching bank transaction
        apiName:
          type: string
          description: Name of the API of the matching bank transaction
          enum:
            - BOX
            - CLOVER
            - STRIPE
            - PLAID
            - KNOX
            - UBER
            - FRESHBOOKS
            - HARVEST
            - KW
            - FRESHBOOKS2
            - CAPITAL_ONE
            - SQUARE
            - DOTLOOP
            - REALOGY
            - UPWORK
            - SHOPIFY
            - DEDUCTR
            - ENTERPRISE
            - MOXIWORKS
            - APPDIRECT
            - LONEWOLF
            - LONEWOLF_TRANSACTIONDESK
            - SAMPLE_BANK
            - TAXBOT
            - GUSTO
            - XERO
            - UNIT
            - MOOV
            - QBO
            - QUALPAY
            - BENCH
            - PARTNER_IMPLEMENTATION
            - CHECK
            - RUTTER
            - WAVE
            - MANUAL_ENTRY
            - CSV_IMPORT
            - ADYEN
            - PAYABLI
        apiInstitutionId:
          type: string
          description: >-
            Id of the institution that the matching bank transaction originated
            from
          nullable: true
        bankAccount:
          $ref: '#/components/schemas/BankAccountExpanded'
      description: The bank transaction matched to this payroll line item
      nullable: true
    PaymentChildGetDto:
      required:
        - amount
        - apiItemId
        - bill
        - category
        - customer
        - description
        - dimensionValues
        - displayName
        - glAccount
        - id
        - invoice
        - type
        - vendor
      type: object
      properties:
        id:
          type: string
          description: Id of the child payment
          example: itm_349412
        type:
          type: string
          description: Type of the child payment
          enum:
            - EXPENSE
            - REVENUE
            - TRANSFER_IN
            - TRANSFER_OUT
            - TAX_EXPENSE
            - INVOICE_REVENUE
            - PAYMENT_IN
            - PAYMENT_OUT
            - PAYROLL_EXPENSE
            - BILL_EXPENSE
            - LOAN_EXPENSE
        amount:
          type: integer
          description: Total amount of the child payment (in cents)
          format: int32
          example: -134051
        displayName:
          type: string
          description: Child payment display name
          example: Gusto
        description:
          type: string
          description: Child payment description
          example: 'WITHDRAWAL ACH GUSTO TAXID: 4001'
        apiItemId:
          type: string
          description: Id of the child payment item on associated API
          nullable: true
        dimensionValues:
          maxItems: 4
          type: array
          items:
            $ref: '#/components/schemas/DimensionValueExpanded'
        customer:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/CustomerExpanded'
        vendor:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/VendorExpanded'
        category:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/CategoryExpanded'
        glAccount:
          $ref: '#/components/schemas/GlAccountExpanded'
        invoice:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/InvoiceExpanded'
        bill:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/BillExpanded'
      description: List of child payments
    DimensionExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension
          example: dim_4521
        name:
          type: string
          description: Name of the dimension
          example: Region
        requiredness:
          type: string
          description: Requiredness of the dimension
          example: NOT_REQUIRED
          enum:
            - REQUIRED
            - NOT_REQUIRED
      description: Dimension for this dimension value
    ChildDimensionValue:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension value
          example: dv_593052
        dimension:
          $ref: '#/components/schemas/DimensionExpanded'
        name:
          type: string
          description: Name of the dimension value
          example: Washington DC
        child:
          $ref: '#/components/schemas/ChildDimensionValue'
      description: Child dimension value, if applicable
    InvoiceExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the invoice
        name:
          type: string
          description: Name of the invoice
        date:
          type: string
          description: Date of the invoice
          format: date
        lineItems:
          type: array
          items:
            $ref: '#/components/schemas/InvoiceLineItem'
      description: Invoice associated with this time entry
      nullable: true
    BillExpanded:
      required:
        - id
      type: object
      properties:
        id:
          type: string
          description: Id of the bill
        name:
          type: string
          description: Name of the bill
        lineItems:
          type: array
          items:
            $ref: '#/components/schemas/BillLineItem'
      description: Bill associated with this child payment
      nullable: true
    InvoiceLineItem:
      type: object
      properties:
        id:
          type: string
          description: Id of the invoice line item
          example: ili_123456
        amount:
          type: integer
          description: Total amount of the invoice line item (in cents)
          format: int32
          example: 5001
      description: Line items of the invoice
    BillLineItem:
      type: object
      properties:
        id:
          type: string
          description: Id of the bill line item
          example: bli_123456
        amount:
          type: integer
          description: Total amount of the bill line item (in cents)
          format: int32
          example: 5001
      description: Line items of the bill
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````